
#include <iostream>

#include "abstractDataTypes/SubsetUnion.hpp"
#include "uniModelExample_ecore/UniModelExample_ecoreFactory.hpp"
#include "uniModelExample_ecore/UniModelExample_ecorePackage.hpp"

#include "uniModelExample_ecore/University.hpp"
#include "uniModelExample_ecore/Faculty.hpp"
#include "uniModelExample_ecore/Lecture.hpp"
#include "uniModelExample_ecore/Student.hpp"
#include "uniModelExample_ecore/Exam.hpp"
#include "uniModelExample_ecore/NamedClass.hpp"

// Start of user code includes 
// You may manually edit additional includes, won't be overwritten upon generation.

// End of user code

using namespace uniModelExample_ecore;

// Start of user code functions 
// You may manually edit additional functions, won't be overwritten upon generation.

// End of user code

int main ()
{
	//Create Model Factory and Package
	std::shared_ptr<UniModelExample_ecoreFactory> factory = UniModelExample_ecoreFactory::eInstance();
	std::shared_ptr<UniModelExample_ecorePackage> package = UniModelExample_ecorePackage::eInstance();

// Creating a new instance of University via model factory
    	std::shared_ptr<University> university = factory->createUniversity();

// Creating a new instance of Faculty via model factory
    	std::shared_ptr<Faculty> faculty_1 = 
factory->createFaculty_in_University(university);

// Creating a new instance of Student via model factory
    	std::shared_ptr<Student> student_1 = factory->createStudent();
    
// Creating two Lecture instances in Faculty 1 via model factory
    	std::shared_ptr<Lecture> lecture_1 = factory->createLecture();
    	std::shared_ptr<Lecture> lecture_2 = factory->createLecture();

// Creating two Exam instances in Student 1
    	std::shared_ptr<Exam> exam_1 = factory->createExam();
    	std::shared_ptr<Exam> exam_2 = factory->createExam();


// Setting parameters for Faculty 1
    	faculty_1->setName("Computer Science"); 
    	faculty_1->getStudents()->add(student_1);

// Setting parameters for Student 1
    	student_1->setName("John Doe");                 
    	student_1->setMatNum(12345);
    	student_1->getLectures()->add(lecture_1);
    	student_1->getLectures()->add(lecture_2);
	student_1->getExams()->add(exam_1);
    	student_1->getExams()->add(exam_2);

// Setting parameters for Lectures 1 and 2
    	lecture_1->setName("Software Design"); 
    	lecture_2->setName("Model Driven Development"); 

// Setting parameters for Exams 1 and 2
    	exam_1->setLecture(lecture_1);
    	exam_1->setScore((float)1.7);
    	exam_2->setLecture(lecture_2);
    	exam_2->setScore((float)1.0);


// Custom output function printUniversity()
    	university->printUniversity();


// Start of user code main
// You may manually edit the following lines, won't be overwritten upon generation.

// End of user code

    return 0;

}
