#include "uniModelExample_ecore/impl/ExamImpl.hpp"

#ifdef NDEBUG
	#define DEBUG_MESSAGE(a) /**/
#else
	#define DEBUG_MESSAGE(a) a
#endif

#ifdef ACTIVITY_DEBUG_ON
    #define ACT_DEBUG(a) a
#else
    #define ACT_DEBUG(a) /**/
#endif

//#include "util/ProfileCallCount.hpp"

#include <cassert>
#include <iostream>
#include <sstream>


#include "abstractDataTypes/SubsetUnion.hpp"
#include "ecore/EAnnotation.hpp"
#include "ecore/EClass.hpp"
#include "uniModelExample_ecore/impl/UniModelExample_ecorePackageImpl.hpp"

//Forward declaration includes
#include "persistence/interfaces/XLoadHandler.hpp" // used for Persistence
#include "persistence/interfaces/XSaveHandler.hpp" // used for Persistence
#include "uniModelExample_ecore/UniModelExample_ecoreFactory.hpp"
#include "uniModelExample_ecore/UniModelExample_ecorePackage.hpp"
#include <exception> // used in Persistence

#include "uniModelExample_ecore/Lecture.hpp"

#include "ecore/EcorePackage.hpp"
#include "ecore/EcoreFactory.hpp"
#include "uniModelExample_ecore/UniModelExample_ecorePackage.hpp"
#include "uniModelExample_ecore/UniModelExample_ecoreFactory.hpp"
#include "ecore/EAttribute.hpp"
#include "ecore/EStructuralFeature.hpp"

using namespace uniModelExample_ecore;

//*********************************
// Constructor / Destructor
//*********************************
ExamImpl::ExamImpl()
{
	//*********************************
	// Attribute Members
	//*********************************
	
	//*********************************
	// Reference Members
	//*********************************
	//References
	

	//Init references
	
}

ExamImpl::~ExamImpl()
{
#ifdef SHOW_DELETION
	std::cout << "-------------------------------------------------------------------------------------------------\r\ndelete Exam "<< this << "\r\n------------------------------------------------------------------------ " << std::endl;
#endif
}




ExamImpl::ExamImpl(const ExamImpl & obj):ExamImpl()
{
	//create copy of all Attributes
	#ifdef SHOW_COPIES
	std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\r\ncopy Exam "<< this << "\r\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ " << std::endl;
	#endif
	m_score = obj.getScore();

	//copy references with no containment (soft copy)
	
	m_lecture  = obj.getLecture();


	//Clone references with containment (deep copy)


}

std::shared_ptr<ecore::EObject>  ExamImpl::copy() const
{
	std::shared_ptr<ExamImpl> element(new ExamImpl(*this));
	element->setThisExamPtr(element);
	return element;
}

std::shared_ptr<ecore::EClass> ExamImpl::eStaticClass() const
{
	return UniModelExample_ecorePackageImpl::eInstance()->getExam_EClass();
}

//*********************************
// Attribute Setter Getter
//*********************************
void ExamImpl::setScore(float _score)
{
	m_score = _score;
} 

float ExamImpl::getScore() const 
{
	return m_score;
}

//*********************************
// Operations
//*********************************

//*********************************
// References
//*********************************
std::shared_ptr<uniModelExample_ecore::Lecture > ExamImpl::getLecture() const
{

    return m_lecture;
}
void ExamImpl::setLecture(std::shared_ptr<uniModelExample_ecore::Lecture> _lecture)
{
    m_lecture = _lecture;
}

//*********************************
// Union Getter
//*********************************


std::shared_ptr<Exam> ExamImpl::getThisExamPtr() const
{
	return m_thisExamPtr.lock();
}
void ExamImpl::setThisExamPtr(std::weak_ptr<Exam> thisExamPtr)
{
	m_thisExamPtr = thisExamPtr;
}
std::shared_ptr<ecore::EObject> ExamImpl::eContainer() const
{
	return nullptr;
}

//*********************************
// Structural Feature Getter/Setter
//*********************************
Any ExamImpl::eGet(int featureID, bool resolve, bool coreType) const
{
	switch(featureID)
	{
		case UniModelExample_ecorePackage::EXAM_EREFERENCE_LECTURE:
			return eAny(getLecture()); //41
		case UniModelExample_ecorePackage::EXAM_EATTRIBUTE_SCORE:
			return eAny(getScore()); //40
	}
	return ecore::EObjectImpl::eGet(featureID, resolve, coreType);
}
bool ExamImpl::internalEIsSet(int featureID) const
{
	switch(featureID)
	{
		case UniModelExample_ecorePackage::EXAM_EREFERENCE_LECTURE:
			return getLecture() != nullptr; //41
		case UniModelExample_ecorePackage::EXAM_EATTRIBUTE_SCORE:
			return getScore() != 0; //40
	}
	return ecore::EObjectImpl::internalEIsSet(featureID);
}
bool ExamImpl::eSet(int featureID, Any newValue)
{
	switch(featureID)
	{
		case UniModelExample_ecorePackage::EXAM_EREFERENCE_LECTURE:
		{
			// BOOST CAST
			std::shared_ptr<uniModelExample_ecore::Lecture> _lecture = newValue->get<std::shared_ptr<uniModelExample_ecore::Lecture>>();
			setLecture(_lecture); //41
			return true;
		}
		case UniModelExample_ecorePackage::EXAM_EATTRIBUTE_SCORE:
		{
			// BOOST CAST
			float _score = newValue->get<float>();
			setScore(_score); //40
			return true;
		}
	}

	return ecore::EObjectImpl::eSet(featureID, newValue);
}

//*********************************
// Persistence Functions
//*********************************
void ExamImpl::load(std::shared_ptr<persistence::interfaces::XLoadHandler> loadHandler)
{
	std::map<std::string, std::string> attr_list = loadHandler->getAttributeList();
	loadAttributes(loadHandler, attr_list);

	//
	// Create new objects (from references (containment == true))
	//
	// get UniModelExample_ecoreFactory
	std::shared_ptr<uniModelExample_ecore::UniModelExample_ecoreFactory> modelFactory = uniModelExample_ecore::UniModelExample_ecoreFactory::eInstance();
	int numNodes = loadHandler->getNumOfChildNodes();
	for(int ii = 0; ii < numNodes; ii++)
	{
		loadNode(loadHandler->getNextNodeName(), loadHandler, modelFactory);
	}
}		

void ExamImpl::loadAttributes(std::shared_ptr<persistence::interfaces::XLoadHandler> loadHandler, std::map<std::string, std::string> attr_list)
{
	try
	{
		std::map<std::string, std::string>::const_iterator iter;
	
		iter = attr_list.find("score");
		if ( iter != attr_list.end() )
		{
			// this attribute is a 'float'
			float value;
			std::istringstream ( iter->second ) >> value;
			this->setScore(value);
		}
		std::shared_ptr<ecore::EClass> metaClass = this->eClass(); // get MetaClass
		iter = attr_list.find("lecture");
		if ( iter != attr_list.end() )
		{
			// add unresolvedReference to loadHandler's list
			loadHandler->addUnresolvedReference(iter->second, loadHandler->getCurrentObject(), metaClass->getEStructuralFeature("lecture")); // TODO use getEStructuralFeature() with id, for faster access to EStructuralFeature
		}
	}
	catch (std::exception& e)
	{
		std::cout << "| ERROR    | " << e.what() << std::endl;
	}
	catch (...) 
	{
		std::cout << "| ERROR    | " <<  "Exception occurred" << std::endl;
	}

	ecore::EObjectImpl::loadAttributes(loadHandler, attr_list);
}

void ExamImpl::loadNode(std::string nodeName, std::shared_ptr<persistence::interfaces::XLoadHandler> loadHandler, std::shared_ptr<uniModelExample_ecore::UniModelExample_ecoreFactory> modelFactory)
{


	ecore::EObjectImpl::loadNode(nodeName, loadHandler, ecore::EcoreFactory::eInstance());
}

void ExamImpl::resolveReferences(const int featureID, std::list<std::shared_ptr<ecore::EObject> > references)
{
	switch(featureID)
	{
		case UniModelExample_ecorePackage::EXAM_EREFERENCE_LECTURE:
		{
			if (references.size() == 1)
			{
				// Cast object to correct type
				std::shared_ptr<uniModelExample_ecore::Lecture> _lecture = std::dynamic_pointer_cast<uniModelExample_ecore::Lecture>( references.front() );
				setLecture(_lecture);
			}
			
			return;
		}
	}
	ecore::EObjectImpl::resolveReferences(featureID, references);
}

void ExamImpl::save(std::shared_ptr<persistence::interfaces::XSaveHandler> saveHandler) const
{
	saveContent(saveHandler);

	
	ecore::EObjectImpl::saveContent(saveHandler);
	
}

void ExamImpl::saveContent(std::shared_ptr<persistence::interfaces::XSaveHandler> saveHandler) const
{
	try
	{
		std::shared_ptr<uniModelExample_ecore::UniModelExample_ecorePackage> package = uniModelExample_ecore::UniModelExample_ecorePackage::eInstance();

	
 
		// Add attributes
		if ( this->eIsSet(package->getExam_EAttribute_score()) )
		{
			saveHandler->addAttribute("score", this->getScore());
		}

		// Add references
		saveHandler->addReference("lecture", this->getLecture());

	}
	catch (std::exception& e)
	{
		std::cout << "| ERROR    | " << e.what() << std::endl;
	}
}

