#include "uniModelExample_ecore/impl/UniModelExample_ecorePackageImpl.hpp"

#include <cassert>

#include "abstractDataTypes/SubsetUnion.hpp"
//metametamodel classes
#include "ecore/EAttribute.hpp"
#include "ecore/EClass.hpp"
#include "ecore/EDataType.hpp"
#include "ecore/EOperation.hpp"
#include "ecore/EReference.hpp"

//metamodel factory
#include "uniModelExample_ecore/UniModelExample_ecoreFactory.hpp"

//depending model packages
#include "ecore/EcorePackage.hpp"

using namespace uniModelExample_ecore;

bool UniModelExample_ecorePackageImpl::isInited = false;

UniModelExample_ecorePackageImpl::UniModelExample_ecorePackageImpl()
{
	setEFactoryInstance(std::shared_ptr<ecore::EFactory >( UniModelExample_ecoreFactory::eInstance()));
}

UniModelExample_ecorePackageImpl::~UniModelExample_ecorePackageImpl()
{
}

UniModelExample_ecorePackage* UniModelExample_ecorePackageImpl::create()
{
	if (isInited)
	{
		return UniModelExample_ecorePackage::eInstance().get();
	}
	isInited = true;
	 
    // Obtain or create package and create package meta-data objects
    UniModelExample_ecorePackageImpl * metaModelPackage = new UniModelExample_ecorePackageImpl();
    return metaModelPackage;
}

void UniModelExample_ecorePackageImpl::init(std::shared_ptr<ecore::EPackage> package)
{
    // Initialize created meta-data
	createPackageContents(package);
	setThisEPackagePtr(package);
    initializePackageContents();   
}

// Begin Class Exam
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getExam_EClass() const
{
	return m_exam_EClass;
}

std::shared_ptr<ecore::EAttribute> UniModelExample_ecorePackageImpl::getExam_EAttribute_score() const
{
	return m_exam_EAttribute_score;
}

std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getExam_EReference_lecture() const
{
	return m_exam_EReference_lecture;
}


// End Class Exam

// Begin Class Faculty
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getFaculty_EClass() const
{
	return m_faculty_EClass;
}


std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getFaculty_EReference_lectures() const
{
	return m_faculty_EReference_lectures;
}
std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getFaculty_EReference_students() const
{
	return m_faculty_EReference_students;
}
std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getFaculty_EReference_university() const
{
	return m_faculty_EReference_university;
}


// End Class Faculty

// Begin Class Lecture
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getLecture_EClass() const
{
	return m_lecture_EClass;
}




// End Class Lecture

// Begin Class NamedClass
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getNamedClass_EClass() const
{
	return m_namedClass_EClass;
}

std::shared_ptr<ecore::EAttribute> UniModelExample_ecorePackageImpl::getNamedClass_EAttribute_name() const
{
	return m_namedClass_EAttribute_name;
}



// End Class NamedClass

// Begin Class Student
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getStudent_EClass() const
{
	return m_student_EClass;
}

std::shared_ptr<ecore::EAttribute> UniModelExample_ecorePackageImpl::getStudent_EAttribute_matNum() const
{
	return m_student_EAttribute_matNum;
}

std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getStudent_EReference_exams() const
{
	return m_student_EReference_exams;
}
std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getStudent_EReference_lectures() const
{
	return m_student_EReference_lectures;
}

std::shared_ptr<ecore::EOperation> UniModelExample_ecorePackageImpl::getStudent_EOperation_getAvgGrade() const
{
	return m_student_EOperation_getAvgGrade;
}

// End Class Student

// Begin Class University
std::shared_ptr<ecore::EClass> UniModelExample_ecorePackageImpl::getUniversity_EClass() const
{
	return m_university_EClass;
}


std::shared_ptr<ecore::EReference> UniModelExample_ecorePackageImpl::getUniversity_EReference_faculties() const
{
	return m_university_EReference_faculties;
}

std::shared_ptr<ecore::EOperation> UniModelExample_ecorePackageImpl::getUniversity_EOperation_printUniversity() const
{
	return m_university_EOperation_printUniversity;
}

// End Class University

